%define perl_version %(perl -MConfig -e 'print $Config{version}')

Summary: The drakxtools (diskdrake, ...)
Name:    drakxtools
Version: 17.18
Release: %mkrel 8
Url:     http://mageia.org/
Source0: %name-%version.tar.xz
Source1: drakbug-32
Patch0:  diskdrake-fix-patitions-not-displayed.patch
License: GPLv2+
Group: System/Configuration
Requires: %{name}-curses = %version-%release
Requires: perl-Gtk3
Requires: perl-Glib
Requires: perl-Net-DBus
Requires: perl-Gtk3-WebKit
Requires: perl-Cairo-GObject
Requires: perl-Gtk3-Notify
Requires: font-tools
Requires: libxxf86misc
Requires: xset
Requires: drakx-net
Requires: ldetect-lst
Requires: freetype-tools
Requires: polkit
Requires: gksu
Requires: drakwizard
Requires: harddrake
Requires: harddrake-ui
Requires: adwaita-icon-theme
BuildRequires: gettext
BuildRequires: ldetect-devel
BuildRequires: perl-devel
BuildRequires: perl-MDK-Common-devel
BuildRequires: %{_lib}parted-devel
BuildRequires: %{_lib}ncurses-devel
BuildRequires: drakx-installer-binaries 
BuildRequires: intltool
Provides: draksec
Obsoletes: draksec
Obsoletes: drakbackup
%global __requires_exclude perl\\((Net::FTP|Time::localtime|URPM|Xconfig.*|[a-z].*)\\)

%package curses
Summary: The drakxtools (diskdrake, ...)
Group: System/Configuration
Requires: perl-base
Requires: perl-Locale-gettext
Requires: %{name}-backend = %version-%release
Requires: drakx-net-text
Obsoletes: diskdrake kbdconfig mouseconfig setuptool drakfloppy
Obsoletes: drakxtools-newt
Provides: diskdrake, kbdconfig mouseconfig setuptool, drakfloppy = %version-%release
Provides: drakxtools-newt = %version-%release
%global __requires_exclude perl\\((Gtk3::WebKit|Xconfig::various|[a-z].*)\\)

%package backend
Summary: Drakxtools libraries and background tools 
Group: System/Configuration
Requires: dmidecode
Requires: perl-File-FnMatch
Requires: perl-String-ShellQuote
Requires(post): perl-MDK-Common
Requires: nmap
Requires: drakxtools-gtk2-compat

%package http
Summary: The drakxtools via http
Group: System/Configuration
Requires: %{name}-curses = %version-%release
Requires: perl-Net-SSLeay
Requires: perl-Authen-PAM
Requires: perl-CGI
Requires(pre): rpm-helper
Requires(post): rpm-helper

%package gtk2-compat
Summary: Gtk2 compatibility modules
Group: System/Configuration
Requires: %{name}

%package -n drakx-finish-install
Summary: First boot configuration
Group: System/Configuration
Requires: %{name} = %version-%release
Requires: drakx-installer-matchbox

%package -n harddrake
Summary: Main Hardware Configuration/Information Tool
Group: System/Configuration
Requires: %{name}-curses = %version-%release
Obsoletes: kudzu, kudzu-devel, libdetect0, libdetect0-devel, libdetect-lst, libdetect-lst-devel, detect, detect-lst
Provides: kudzu = %version, kudzu-devel = %version, libdetect0, libdetect0-devel, libdetect-lst, libdetect-lst-devel, detect, detect-lst
Requires(pre): rpm-helper
Requires(post): rpm-helper
Requires: libdrakx-net
Requires: libdrakx-kbd-mouse-x11
Requires: libdrak3d


%package -n harddrake-ui
Summary: Main Hardware Configuration/Information Tool
Group: System/Configuration
Requires: %name = %version-%release
Requires: sane-backends
Requires: libdrakx-net
Requires: libdrakx-kbd-mouse-x11
Requires: libdrak3d

%description
Contains many Linux applications simplifying users and
administrators life on a Linux machine. Nearly all of
them work both under X.Org (graphical environment) and in console
(text environment), allowing easy distant work.

- drakbug: interactive bug report tool
- drakbug_report: help find bugs in DrakX
- drakclock: date & time configurator
- drakfloppy: boot disk creator
- drakfont: import fonts in the system
- draklog: show extracted information from the system logs
- drakperm: msec GUI (permissions configurator)
- draksec: security options managment / msec frontend

%description backend
See package %name

%description curses
Contains many Linux applications simplifying users and
administrators life on a Linux machine. Nearly all of
them work both under X.Org (graphical environment) and in console
(text environment), allowing easy distant work.

- adduserdrake: help you adding a user
- diskdrake: DiskDrake makes hard disk partitioning easier. It is
  graphical, simple and powerful. Different skill levels are available
  (newbie, advanced user, expert). It's written entirely in Perl and
  Perl/Gtk. It uses resize_fat which is a perl rewrite of the work of
  Andrew Clausen (libresize).
- drakauth: configure authentification (LDAP/NIS/...)
- drakautoinst: help you configure an automatic installation replay
- drakboot: configures your boot configuration (Lilo/GRUB,
  Bootsplash, X, autologin)
- drakkeyboard: configure your keyboard (both console and X)
- draklocale: language configurator, available both for root
  (system wide) and users (user only)
- drakmouse: autodetect and configure your mouse
- drakscanner: scanner configurator
- draksound: sound card configuration
- drakx11: menu-driven program which walks you through setting up
  your X server; it autodetects both monitor and video card if
  possible
- drakxservices: SysV services and daemons configurator
- drakxtv: auto configure tv card for xawtv grabber
- lsnetdrake: display available nfs and smb shares
- lspcidrake: display your pci information, *and* the corresponding
  kernel module

%description http
This package lets you configure your computer through your Web browser:
it provides an HTTP interface to the tools found in the drakxtools
package.

%description gtk2-compat
This package provides Gtk2 compatibility modules for legacy tools.

%description -n drakx-finish-install
For OEM-like duplications, it allows at first boot:
- network configuration
- creating users
- setting root password
- choosing authentication


%description -n harddrake
The harddrake service is a hardware probing tool run at system boot
time to determine what hardware has been added or removed from the
system.
It then offer to run needed config tool to update the OS
configuration.


%description -n harddrake-ui
This is the main configuration tool for hardware that calls all the
other configuration tools.
It offers a nice GUI that show the hardware configuration splitted by
hardware classes.


%prep
%setup -q
%patch0 -p1

# needed when tarball cames from git-svn:
cd perl-install; [ -f Makefile.drakxtools ] && mv Makefile.drakxtools Makefile

%build
%make -C perl-install CFLAGS="$RPM_OPT_FLAGS"

%install
rm -rf %buildroot
%make -C perl-install PREFIX=%buildroot install
mkdir -p %buildroot%_sysconfdir/{X11/xinit.d,X11/wmsession.d,sysconfig/harddrake2}
touch %buildroot/etc/sysconfig/harddrake2/previous_hw

#make sure it is no
perl -pi -e "s|FINISH_INSTALL=yes|FINISH_INSTALL=no|" %buildroot/etc/sysconfig/finish-install

dirs1="usr/lib/libDrakX usr/share/libDrakX"
(cd %buildroot ; find $dirs1 usr/bin usr/sbin usr/libexec usr/share/polkit-1 ! -type d -printf "/%%p\n")|grep -E -v 'bin/.*harddrake' > %{name}.list
(cd %buildroot ; find $dirs1 -type d -printf "%%%%dir /%%p\n") >> %{name}.list

perl -ni -e '/Xdrakres|clock|display_help|display_release_notes.pl|drak(bug$|clock|dvb|floppy|font|hosts|log|perm|sec|splash)|gtk|icons|logdrake|pixmaps|\.png$/ ? print STDERR $_ : print' %{name}.list 2> %{name}-gtk.list
# exclude gtk2 stuff:
fgrep gtk2 %{name}-gtk.list >%{name}-gtk2.list
perl -pi -e 'undef $_ if /gtk2/' %{name}-gtk.list
perl -ni -e '/http/ ? print STDERR $_ : print' %{name}.list 2> %{name}-http.list
perl -ni -e 'm!lib/libDrakX|bootloader-config|fileshare|lsnetdrake|drakupdate_fstab|rpcinfo|serial_probe! && !/curses/i ? print STDERR $_ : print' %{name}.list 2> %{name}-backend.list
perl -ni -e '/finish-install/ ? print STDERR $_ : print' %{name}.list 2> finish-install.list

#menu entry
mkdir -p %buildroot%{_datadir}/autostart

cat > %buildroot%_sysconfdir/X11/xinit.d/harddrake2 <<EOF
#!/bin/sh
exec /usr/share/harddrake/service_harddrake X11
EOF

cat > %buildroot%_sysconfdir/sysconfig/harddrake2/kernel <<EOF
KERNEL=2.6
EOF

mv %buildroot%_sbindir/service_harddrake_confirm %buildroot%_datadir/harddrake/confirm

chmod +x %buildroot{%_datadir/harddrake/{conf*,service_harddrake},%_sysconfdir/X11/xinit.d/harddrake2}
# temporary fix until we reenable this feature
rm -f %buildroot%_sysconfdir/X11/xinit.d/harddrake2

perl -I perl-install -mharddrake::data -e 'print "DETECT_$_->{class}=yes\n" foreach @harddrake::data::tree' |sort > %buildroot%_sysconfdir/sysconfig/harddrake2/service.conf
echo -e "AUTORECONFIGURE_RIGHT_XORG_DRIVER=yes\n" >> %buildroot%_sysconfdir/sysconfig/harddrake2/service.conf

#dont run drakbug on 32bit
%ifarch %{ix86}
install -m0755 %SOURCE1 %buildroot/usr/bin/drakbug
%endif

%find_lang libDrakX
%find_lang libDrakX-standalone
cat libDrakX.lang libDrakX-standalone.lang >> %name.list

%check
%make -C perl-install check

%post
%make_session
[[ ! -e %_sbindir/kbdconfig ]] && %__ln_s -f keyboarddrake %_sbindir/kbdconfig
[[ ! -e %_sbindir/mouseconfig ]] && %__ln_s -f mousedrake %_sbindir/mouseconfig
:

%postun
%make_session
for i in %_sbindir/kbdconfig %_sbindir/mouseconfig %_bindir/printtool;do
    [[ -L $i ]] && %__rm -f $i
done
:

%post http
%_post_service drakxtools_http

%preun http
%_preun_service drakxtools_http

%postun -n harddrake
file /etc/sysconfig/harddrake2/previous_hw | grep -F -q perl && %_datadir/harddrake/convert || :

%triggerpostun -n harddrake -- harddrake < 11.62-2
rm -f /etc/rc.d/*/{K,S}??harddrake

%files backend -f %{name}-backend.list
%config(noreplace) /etc/security/fileshare.conf
%attr(4755,root,root) %_sbindir/fileshareset

%files curses -f %name.list
%{_datadir}/applications/localedrake*.desktop
#%%doc perl-install/diskdrake/diskdrake.html
%_iconsdir/localedrake.png
%_iconsdir/large/localedrake.png
%_iconsdir/mini/localedrake.png

%files -f %{name}-gtk.list

%files gtk2-compat -f %{name}-gtk2.list

%files -n harddrake
%dir /etc/sysconfig/harddrake2/
%config(noreplace) /etc/sysconfig/harddrake2/previous_hw
%config(noreplace) /etc/sysconfig/harddrake2/service.conf
%config(noreplace) %_sysconfdir/sysconfig/harddrake2/kernel
%dir %_datadir/harddrake/
%_datadir/harddrake/*
%_sysconfdir/X11/xsetup.d/??notify-x11-free-driver-switch.xsetup
#%%_sysconfdir/X11/xinit.d/harddrake2

%files -n harddrake-ui
%dir /etc/sysconfig/harddrake2/
%_sbindir/harddrake2
%_datadir/pixmaps/harddrake2
%{_datadir}/applications/harddrake.desktop
%_iconsdir/large/harddrake.png
%_iconsdir/mini/harddrake.png
%_iconsdir/harddrake.png

%files -n drakx-finish-install
%_sysconfdir/sysconfig/finish-install
%_sysconfdir/X11/xsetup.d/??finish-install.xsetup
%_sbindir/finish-install

%files http -f %{name}-http.list
%dir %_sysconfdir/drakxtools_http
%config(noreplace) %_sysconfdir/pam.d/miniserv
%_sysconfdir/init.d/drakxtools_http
%config(noreplace) %_sysconfdir/drakxtools_http/conf
%config(noreplace) %_sysconfdir/drakxtools_http/authorised_progs
%config(noreplace) %_sysconfdir/logrotate.d/drakxtools-http


%changelog
* Wed Jun 14 2017 adrianomorselli <adrianomorselli> 17.18-8uplos2017
- add new device drivers to list modules
- add requires adwaita-icon-theme instead old gnome-icons-theme-symbolic
